# coding: utf-8
# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from winkirip.builder_dvd import BuilderDVD
from winkirip.builder_file import BuilderFile
from winkirip.container import CONTAINER_DVD, CONTAINER_VCD, CONTAINER_SVCD
from winkirip.container import CONTAINER_FILE, CONTAINER_STREAMS

class BuilderFactory:
    def __init__(self):
        return

    def create_builder(self, project):
        dest = project.get_dest_type()

        builder = None
        if dest == CONTAINER_DVD:
            builder = BuilderDVD(project)

        elif dest == CONTAINER_FILE:
            builder = BuilderFile(project)

        return builder

# vim:number:autoindent:shiftwidth=4:tabstop=4:softtabstop=4:expandtab
