# coding: utf-8
# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from winkirip.constructor import Constructor
from winkirip.lib import debug, error

class ConstructorMove(Constructor):
    def __init__(self):
        Constructor.__init__(self)
        self.__inname = None
        self.__outname = None
        return

    # -- methods inherited from Constructor --

    def construct(self):
        if not self.__inname:
            debug('ConstructorMove.construct()', 'no infile specified', error)
            return False, ''

        if not self.__outname:
            debug('ConstructorMove.construct()', 'no infile specified', error)
            return False, ''

        return True, 'mv %s %s' % (self.__inname, self.__outname)

    # -- public interface --

    def set_outname(self, outname):
        self.__outname = outname
        return

    def set_inname(self, inname):
        self.__inname = inname
        return

# vim:number:autoindent:shiftwidth=4:tabstop=4:softtabstop=4:expandtab
