# coding: utf-8
# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from container import CONTAINER_UNKNOWN, CONTAINER_DVD, CONTAINER_VCD
from container import CONTAINER_SVCD, CONTAINER_FILE, CONTAINER_STREAMS
from winkirip.constructor import Constructor

class ConstructorTcrequant(Constructor):
    def __init__(self, tools):
        Constructor.__init__(self)
        self.__tools = tools
        self.__srctype = CONTAINER_UNKNOWN
        self.__factor = 0.
        self.__inname = None
        self.__outname = None
        return

    # -- methods inherited from Constructor --

    def construct(self):
        prog = None
        if self.__tools.has_tool('tcrequant'):
            prog = self.__tools.get_tool_location('tcrequant')

        if self.__factor < 1.:
            print 'no need to shrink stream'
            return False, ''

        if not prog or not self.__inname or not self.__outname:
            print prog
            print self.__inname
            print self.__outname
            return False, ''

        result = 'cat %s | %s -f %f > %s' % (self.__inname, prog, self.__factor, self.__outname)
        return True, result

    # -- public interface --

    def set_source_type(self, srctype):
        self.__srctype = srctype
        return

    def set_quant_factor(self, factor):
        self.__factor = factor
        return

    def set_outname(self, outname):
        self.__outname = outname
        return

    def set_inname(self, inname):
        self.__inname = inname
        return

# vim:number:autoindent:shiftwidth=4:tabstop=4:softtabstop=4:expandtab
