# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from copy import deepcopy

class Chapter:
    def __init__(self, src = None):
        self.__id = -1
        self.__title_id = -1
        self.__container_id = -1
        self.__length = 0.
        self.__name = None
        self.__source = None

        if src:
            self.__id = src.__id
            self.__title_id = src.__title_id
            self.__container_id = src.__container_id 
            self.__length = src.__length
            self.__name = deepcopy(src.__name)
        return

    # -- get/set --

    def get_id(self):
        return self.__id

    def get_title_id(self):
        return self.__title_id

    def get_container_id(self):
        return self.__container_id

    def get_length(self):
        return self.__length

    def get_name(self):
        return self.__name

    def get_source(self):
        return self.__source

    def set_id(self, id):
        self.__id = id
        return

    def set_title_id(self, title_id):
        self.__title_id = title_id
        return

    def set_container_id(self, container_id):
        self.__container_id = container_id
        return

    def set_length(self, length):
        self.__length = length
        return

    def set_name(self, name):
        self.__name = name
        return

    def set_source(self, source):
        if isinstance(source, Chapter):
            self.__source = source
        else:
            assert(False)
        return

    # -- public interface --

    def copy(self):
        return Chapter(self)

    def __repr__(self):
        return '    Chapter(%s, %d, len: %f [%d/%d])\n' % (self.__name, self.__id, self.__length, self.__container_id, self.__title_id)

# vim:number:autoindent:shiftwidth=4:tabstop=4:softtabstop=4:expandtab
