# coding: utf-8
# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from winkirip.worker_chapters_tags import WorkerChaptersTags
from winkirip.container import CONTAINER_DVD, CONTAINER_FILE
from winkirip.container import FILE_MATROSKA, FILE_MP4
from winkirip.lib import debug, error

class FactoryChaptersTags:
    def __init__(self, project):
        self.__project = project
        return

    def create_workers(self, context):
        cfg = self.__project.get_config()
        dest_cont_type = self.__project.get_dest_type()
        dest_containers = self.__project.get_dest()
        result = []

        for dest_cont in dest_containers:

            if dest_cont_type == CONTAINER_DVD:
                worker = WorkerChaptersTags(context)
                result.append(worker)

            elif dest_cont_type == CONTAINER_FILE:
                file_encoding = cfg.get_file_encoding()

                if file_encoding == FILE_MATROSKA or file_encoding == FILE_MP4:
                    worker = WorkerChaptersTags(context)
                    result.append(worker)

            else:
                debug('FactoryChaptersTags.create_workers()', 'unknown dest container type', error)

        return result


# vim:number:autoindent:shiftwidth=4:tabstop=4:softtabstop=4:expandtab
