# coding: utf-8
# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from winkirip.factory_base import BaseFactory
from winkirip.worker_palette_dvd import WorkerPaletteDVD
from winkirip.container import CONTAINER_DVD, CONTAINER_FILE
from winkirip.lib import debug, error

class FactoryPalette(BaseFactory):
    def __init__(self, project):
        BaseFactory.__init__(self, project)
        return

    def create_worker(self, context, source_cid):
        dest_cont_type = self.get_project().get_dest_type()
        slist = self.get_subtitle_list(source_cid)

        worker = None
        if dest_cont_type == CONTAINER_DVD:
            # no subtitles are selected: no need to create palette
            if len(slist) < 1:
                return None

            worker = WorkerPaletteDVD(context, source_cid)
            
        return worker

# vim:number:autoindent:shiftwidth=4:tabstop=4:softtabstop=4:expandtab
