# coding: utf-8
# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#from winkirip.lib import debug, error, to_int, to_float
from winkirip.container_title import Title
from winkirip.container_subtitle import Subtitle, SUBTITLE_VOBSUB
from winkirip.container_subtitle import SUBTITLE_SRT, SUBTITLE_SUB
from winkirip.container_chapter import Chapter

class SubtitleParser:
    def __init__(self, lines, iso_codes, cont):
        self.__lines = lines
        self.__container = cont
        self.__iso_codes = iso_codes
        return

    def create_container(self, format):
        self.__container.remove_titles()
        title = Title()
        self.__container.add_title(title)

        subtitle = Subtitle()
        subtitle.set_format(format)
        self.__container[0].add_subtitle(subtitle)

        # add one chapter
        chapter = Chapter()
        chapter.set_id(0)
        title.add_chapter(chapter)
        return

    def get_container(self):
        return self.__container

class SrtParser(SubtitleParser):
    def __init__(self, lines, iso_codes,  cont):
        SubtitleParser.__init__(self, lines, iso_codes,  cont)
        return

    # -- public interface --

    def run(self):
        # todo: try to guess the frame rate, length, encoding and language from
        # the lines supplied; or check the file format also?

        self.create_container(SUBTITLE_SRT)
        return True

    # -- helpers --


class SubParser(SubtitleParser):
    def __init__(self, lines, iso_codes,  cont):
        SubtitleParser.__init__(self, lines, iso_codes,  cont)
        return

    # -- public interface --

    def run(self):
        # todo: try to guess the frame rate, length, encoding and language from
        # the lines supplied; or check the file format also?

        self.create_container(SUBTITLE_SUB)
        return True

    # -- helpers --


class VobsubParser(SubtitleParser):
    def __init__(self, lines, iso_codes,  cont):
        SubtitleParser.__init__(self, lines, iso_codes,  cont)
        return

    # -- public interface --

    def run(self):
        self.create_container(SUBTITLE_VOBSUB)
        return True

    # -- helpers --



# vim:number:autoindent:shiftwidth=4:tabstop=4:softtabstop=4:expandtab
