# coding: utf-8
# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004-2007 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


from gtk.glade import XML
from winkirip.lib import build_path, winki_path

class PopupTrayMenu:
    def __init__(self):
        self.__settings_callback = None
        self.__quit_callback = None

        self.__xml = None
        self.__glade_file = build_path([winki_path, 'glade', 'tray_popup.glade'])

        try:
            self.__xml = XML(self.__glade_file, 'popup_menu')
        except:
            print 'PopupTrayMenu: Cannot load popup_menu from %s' % (self.__glade_file)
            raise SystemExit

        dic = self.get_dictionary()
        self.__xml.signal_autoconnect(dic)

        self.__popup = self.__xml.get_widget('popup_menu')
        return

    def get_dictionary(self):
        return {'on_settings_activate' : self.on_settings,
                'on_quit_activate' : self.on_quit}

    def set_settings_callback(self, settings_callback):
        self.__settings_callback = settings_callback
        return

    def set_quit_callback(self, quit_callback):
        self.__quit_callback = quit_callback
        return

    def show(self, button, time):
        self.__popup.popup(None, None, None, button, time)
        return

    def on_settings(self, menu_item):
        if self.__settings_callback:
            self.__settings_callback(None)
        return True

    def on_quit(self, menu_item):
        if self.__quit_callback:
            self.__quit_callback(None)
        return True

